# WEB+DB PRESS Vol.118 連載「Perl Hackers Hub」サンプルコード

技術評論社刊「WEB+DB PRESS Vol.118」の連載「Perl Hackers Hub」第63回「PPIとPerl::Tidyを組み合わせて作るコード整形ツール」（谷脇 真琴著）のサンプルコードです。

## perltidy\_gradual.pl

`perltidy_gradual.pl` は本文「静的解析ライブラリの組み合わせて部分的にコード整形を行う」で紹介した手法を、動作するスクリプトにしたものです。

### 動作確認済み環境

このスクリプトを作成し、動作を確認した環境は以下です。

* macOS Mojave 10.14.6
* Perl 5.30.0
* Carton v1.0.34

### 動作方法

任意のPerl環境でもし、`Carton`が入っていない場合は、`Carton`をインストールします。そしてこの`README.md`があるディレクトリに移動後、以下のコマンドで、依存モジュールを導入します。

```
$ carton install
```

そして以下のコマンドで、実行します。

```
$ carton exec perl perltidy_gradual.pl <実行ディレクトリ> [対象ファイル名...]
```

`<実行ディレクトリ名>`は、整形対象のPerlスクリプトが入っているディレクトリです。Gitでバージョン管理されている必要があります。`[対象ファイル名...]`は、整形対象のファイル名を、実行ディレクトリからの相対パスで列挙します。この引数は省略可能です。省略した場合は、差分が存在する`.pm`および`.pl`のファイル名を探索して実行します。なお、整形を実行するのは、`unstaged`なファイルのみです。
